summaryrefslogtreecommitdiff
path: root/oh-my-zsh/plugins/extract
diff options
context:
space:
mode:
Diffstat (limited to 'oh-my-zsh/plugins/extract')
-rw-r--r--oh-my-zsh/plugins/extract/README.md60
-rw-r--r--oh-my-zsh/plugins/extract/_extract7
-rw-r--r--oh-my-zsh/plugins/extract/extract.plugin.zsh85
3 files changed, 152 insertions, 0 deletions
diff --git a/oh-my-zsh/plugins/extract/README.md b/oh-my-zsh/plugins/extract/README.md
new file mode 100644
index 0000000..44f0b05
--- /dev/null
+++ b/oh-my-zsh/plugins/extract/README.md
@@ -0,0 +1,60 @@
+# extract plugin
+
+This plugin defines a function called `extract` that extracts the archive file
+you pass it, and it supports a wide variety of archive filetypes.
+
+This way you don't have to know what specific command extracts a file, you just
+do `extract <filename>` and the function takes care of the rest.
+
+To use it, add `extract` to the plugins array in your zshrc file:
+
+```zsh
+plugins=(... extract)
+```
+
+## Supported file extensions
+
+| Extension | Description |
+|:------------------|:-------------------------------------|
+| `7z` | 7zip file |
+| `Z` | Z archive (LZW) |
+| `apk` | Android app file |
+| `aar` | Android library file |
+| `bz2` | Bzip2 file |
+| `cab` | Microsoft cabinet archive |
+| `cpio` | Cpio archive |
+| `deb` | Debian package |
+| `ear` | Enterprise Application aRchive |
+| `gz` | Gzip file |
+| `ipa` | iOS app package |
+| `ipsw` | iOS firmware file |
+| `jar` | Java Archive |
+| `lrz` | LRZ archive |
+| `lz4` | LZ4 archive |
+| `lzma` | LZMA archive |
+| `rar` | WinRAR archive |
+| `rpm` | RPM package |
+| `sublime-package` | Sublime Text package |
+| `tar` | Tarball |
+| `tar.bz2` | Tarball with bzip2 compression |
+| `tar.gz` | Tarball with gzip compression |
+| `tar.lrz` | Tarball with lrzip compression |
+| `tar.lz` | Tarball with lzip compression |
+| `tar.lz4` | Tarball with lz4 compression |
+| `tar.xz` | Tarball with lzma2 compression |
+| `tar.zma` | Tarball with lzma compression |
+| `tar.zst` | Tarball with zstd compression |
+| `tbz` | Tarball with bzip compression |
+| `tbz2` | Tarball with bzip2 compression |
+| `tgz` | Tarball with gzip compression |
+| `tlz` | Tarball with lzma compression |
+| `txz` | Tarball with lzma2 compression |
+| `tzst` | Tarball with zstd compression |
+| `war` | Web Application archive (Java-based) |
+| `xpi` | Mozilla XPI module file |
+| `xz` | LZMA2 archive |
+| `zip` | Zip archive |
+| `zst` | Zstandard file (zstd) |
+
+See [list of archive formats](https://en.wikipedia.org/wiki/List_of_archive_formats) for
+more information regarding archive formats.
diff --git a/oh-my-zsh/plugins/extract/_extract b/oh-my-zsh/plugins/extract/_extract
new file mode 100644
index 0000000..27b099c
--- /dev/null
+++ b/oh-my-zsh/plugins/extract/_extract
@@ -0,0 +1,7 @@
+#compdef extract
+#autoload
+
+_arguments \
+ '(-r --remove)'{-r,--remove}'[Remove archive.]' \
+ "*::archive file:_files -g '(#i)*.(7z|Z|apk|aar|bz2|cab|cpio|deb|ear|gz|ipa|ipsw|jar|lrz|lz4|lzma|rar|rpm|sublime-package|tar|tar.bz2|tar.gz|tar.lrz|tar.lz|tar.lz4|tar.xz|tar.zma|tar.zst|tbz|tbz2|tgz|tlz|txz|tzst|war|whl|xpi|xz|zip|zst)(-.)'" \
+ && return 0
diff --git a/oh-my-zsh/plugins/extract/extract.plugin.zsh b/oh-my-zsh/plugins/extract/extract.plugin.zsh
new file mode 100644
index 0000000..1112dd5
--- /dev/null
+++ b/oh-my-zsh/plugins/extract/extract.plugin.zsh
@@ -0,0 +1,85 @@
+alias x=extract
+
+extract() {
+ setopt localoptions noautopushd
+
+ if (( $# == 0 )); then
+ cat >&2 <<'EOF'
+Usage: extract [-option] [file ...]
+
+Options:
+ -r, --remove Remove archive after unpacking.
+EOF
+ fi
+
+ local remove_archive=1
+ if [[ "$1" == "-r" ]] || [[ "$1" == "--remove" ]]; then
+ remove_archive=0
+ shift
+ fi
+
+ local pwd="$PWD"
+ while (( $# > 0 )); do
+ if [[ ! -f "$1" ]]; then
+ echo "extract: '$1' is not a valid file" >&2
+ shift
+ continue
+ fi
+
+ local success=0
+ local extract_dir="${1:t:r}"
+ local file="$1" full_path="${1:A}"
+ case "${file:l}" in
+ (*.tar.gz|*.tgz) (( $+commands[pigz] )) && { pigz -dc "$file" | tar xv } || tar zxvf "$file" ;;
+ (*.tar.bz2|*.tbz|*.tbz2) tar xvjf "$file" ;;
+ (*.tar.xz|*.txz)
+ tar --xz --help &> /dev/null \
+ && tar --xz -xvf "$file" \
+ || xzcat "$file" | tar xvf - ;;
+ (*.tar.zma|*.tlz)
+ tar --lzma --help &> /dev/null \
+ && tar --lzma -xvf "$file" \
+ || lzcat "$file" | tar xvf - ;;
+ (*.tar.zst|*.tzst)
+ tar --zstd --help &> /dev/null \
+ && tar --zstd -xvf "$file" \
+ || zstdcat "$file" | tar xvf - ;;
+ (*.tar) tar xvf "$file" ;;
+ (*.tar.lz) (( $+commands[lzip] )) && tar xvf "$file" ;;
+ (*.tar.lz4) lz4 -c -d "$file" | tar xvf - ;;
+ (*.tar.lrz) (( $+commands[lrzuntar] )) && lrzuntar "$file" ;;
+ (*.gz) (( $+commands[pigz] )) && pigz -dk "$file" || gunzip -k "$file" ;;
+ (*.bz2) bunzip2 "$file" ;;
+ (*.xz) unxz "$file" ;;
+ (*.lrz) (( $+commands[lrunzip] )) && lrunzip "$file" ;;
+ (*.lz4) lz4 -d "$file" ;;
+ (*.lzma) unlzma "$file" ;;
+ (*.z) uncompress "$file" ;;
+ (*.zip|*.war|*.jar|*.ear|*.sublime-package|*.ipa|*.ipsw|*.xpi|*.apk|*.aar|*.whl) unzip "$file" -d "$extract_dir" ;;
+ (*.rar) unrar x -ad "$file" ;;
+ (*.rpm)
+ command mkdir -p "$extract_dir" && builtin cd -q "$extract_dir" \
+ && rpm2cpio "$full_path" | cpio --quiet -id ;;
+ (*.7z) 7za x "$file" ;;
+ (*.deb)
+ command mkdir -p "$extract_dir/control" "$extract_dir/data"
+ builtin cd -q "$extract_dir"; ar vx "$full_path" > /dev/null
+ builtin cd -q control; extract ../control.tar.*
+ builtin cd -q ../data; extract ../data.tar.*
+ builtin cd -q ..; command rm *.tar.* debian-binary ;;
+ (*.zst) unzstd "$file" ;;
+ (*.cab) cabextract -d "$extract_dir" "$file" ;;
+ (*.cpio) cpio -idmvF "$file" ;;
+ (*)
+ echo "extract: '$file' cannot be extracted" >&2
+ success=1 ;;
+ esac
+
+ (( success = success > 0 ? success : $? ))
+ (( success == 0 && remove_archive == 0 )) && rm "$full_path"
+ shift
+
+ # Go back to original working directory in case we ran cd previously
+ builtin cd -q "$pwd"
+ done
+}